<?php

function conf_read ($fn) {

	$fp = @fopen($fn, "r");
	if ($fp) {
		$fcont = fread($fp, filesize($fn));
		fclose($fp);

		$conf_arr = explode("\n", $fcont);

		$ret_arr = array();

		foreach ($conf_arr as $line) {
			if (!empty($line)) {
				$tmp_arr = explode("=", $line);
				$ret_arr[$tmp_arr[0]] = $tmp_arr[1];
			}
		}
	}

	return($ret_arr);
}

function conf_write ($fn, $conf) {

	$fields = array(
		"pop3_host", "pop3_port", "pop3_user", "pop3_pass", "pop3_purge",
		"smtp_host", "smtp_port", "smtp_user", "smtp_pass", "smtp_from", "smtp_rcpt",
		"mail_edge", "smgw_ssl");

	foreach ($fields as $field) {
		if (($field == "pop3_port") && (empty($conf[$field]))) {
			$fcont .= $field . "=110\n";
		} elseif (($field == "smtp_port") && (empty($conf[$field]))) {
			$fcont .= $field . "=25\n";
		} elseif (($field == "mail_edge") && (empty($conf[$field]))) {
			$fcont .= $field ."=SMSEND\n";
		} else {
			$fcont .= $field . "=" . $conf[$field] . "\n";
		}
	}

	$fp = fopen($fn, "w");
	fwrite($fp, $fcont);
	fclose($fp);
}

function conf_print ($conf) {

	$div = "<div style=\"float: left; width: 100px;\">";

	$ret	= "<form action=\"index.php\" name=\"smgw\" method=\"POST\">\n" .
		  "<h3>POP3 Configuration:</h3>\n" .
		  "<div style=\"float: right; width: 150px;\"><input type=\"submit\" name=\"test\" value=\"Test Settings\" /></div>\n" .
		  $div . "Hostname:</div><input type=\"text\" name=\"pop3_host\" value=\"" . $conf[pop3_host] . "\" /><br />\n" .
		  $div . "Port:</div><input type=\"text\" name=\"pop3_port\" value=\"" . $conf[pop3_port] . "\" /><br />\n" .
		  $div . "Username:</div><input type=\"text\" name=\"pop3_user\" value=\"" . $conf[pop3_user] . "\" /><br />\n" .
		  $div . "Password:</div><input type=\"password\" name=\"pop3_pass\" value=\"" . $conf[pop3_pass] . "\" /><br />\n" .
		  "<h3>SMTP Configuration:</h3>\n" .
		  $div . "Hostname:</div><input type=\"text\" name=\"smtp_host\" value=\"" . $conf[smtp_host] . "\" /><br />\n" .
		  $div . "Port:</div><input type=\"text\" name=\"smtp_port\" value=\"" . $conf[smtp_port] . "\" /><br />\n" .
		  $div . "Username:</div><input type=\"text\" name=\"smtp_user\" value=\"" . $conf[smtp_user] . "\" /><br />\n" .
		  $div . "Password:</div><input type=\"password\" name=\"smtp_pass\" value=\"" . $conf[smtp_pass] . "\" /><br />\n" .
		  $div . "From:</div><input type=\"text\" name=\"smtp_from\" value=\"" . $conf[smtp_from] . "\" /><br />\n" .
		  $div . "Recipient:</div><input type=\"text\" name=\"smtp_rcpt\" value=\"" . $conf[smtp_rcpt] . "\" /><br />\n" .
		  "<h3>Generic Configuration:</h3>\n" .
		  $div . "use SSL:</div><input type=\"checkbox\" name=\"smgw_ssl\" value=\"1\" " .
		  ($conf[smgw_ssl] ? "checked " : "") . " />\n" .
		  "<div style=\"float: right; width: 150px;\"><input type=\"submit\" name=\"save\" value=\"Save Settings\" /></div>\n" .
		  "</form>\n";

	return($ret);

}

function log_print ($fn) {

	$ret = "<div style=\"font-family: monospace; height: 300px; width: 700px; overflow: scroll; white-space: nowrap;\">\n";

	if (!file_exists($fn)) {
		$ret .= "File empty.<br />\n";
		$ret .= "</div>\n";

		return($ret);
	}

	$data = array_slice(file($fn), -64);

	foreach ($data as $line) {
		$ret .= $line . "<br />\n";
	}

	$ret .= "</div>\n";

	return($ret);
}

function conf_test ($conf) {

	$cmd =  "../bin/mail_test" .
		" --ph " . $conf[pop3_host] . " --pp " . $conf[pop3_port] . " --pu " . $conf[pop3_user] . " --px " . $conf[pop3_pass] .
		" --sh " . $conf[smtp_host] . " --sp " . $conf[smtp_port] . " --su " . $conf[smtp_user] . " --sx " . $conf[smtp_pass] .
		($conf[smgw_ssl] == 1 ? " --ssl" : "");

	putenv("LD_LIBRARY_PATH=../lib");
	exec($cmd, $test_res);

	return($test_res);
}

function test_print ($test_res) {

	if (empty($test_res)) {
		return("");
	}

	$color_pop3 = ($test_res[0] == "OK" ? "green" : "red");
	$color_smtp = ($test_res[1] == "OK" ? "green" : "red");

	$ret =	"<h2>Results of Configuration-Test</h2>\n" .
		"POP3: <div style=\"float: right; width: 75px; color: " . $color_pop3 . ";\">" . $test_res[0] . "</div><br />\n" .
		"SMTP: <div style=\"float: right; width: 75px; color: " . $color_smtp . ";\">" . $test_res[1] . "</div>\n";

	return($ret);
}

@session_start();
if (!isset($_SESSION['beroari_time'])) {
	header("Location: /app/berogui");
} elseif ((isset($_SESSION['beroari_time'])) && (($_SESSION['beroari_time'] + 1200) < time())) {
	@session_unset();
	@session_destroy();
	header("Location: /app/berogui");
}

$_SESSION['beroari_time'] = time();

if (!(empty($_POST["save"]))) {
	conf_write("../etc/smgw.conf", $_POST);
}

if (!empty($_POST["test"])) {
	$conf = $_POST;
	$test_res = conf_test($conf);
} else {
	$conf = conf_read("../etc/smgw.conf");
}

echo	"<xml version=\"1.0\" encoding=\"UTF-8\">\n" .
	"	<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\" \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">\n" .
	"<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\">\n" .
	"<head>\n" .
	"	<link type=\"text/css\" href=\"css/beroApp.css\" rel=\"Stylesheet\" />\n" .
	"	<title>SMGW</title>\n" .
	"</head>\n" .
	"<body>\n" .
	"	<div class=\"main\">\n" .
	"		<div class=\"top\"><img src=\"img/bg_top.png\"></div>\n" .
	"		<div class=\"left\">\n" .
	"			<div>Menu: <a href=\"/app/berogui\">berogui</a> | <a href=\"\">reload</a></div>\n" .
	"			<h1>SMGW</h1>\n" .
	"			<h2>Configuration</h2>\n" .
	conf_print($conf) .
	test_print($test_res) .
	"			<h2>Logfile</h2>\n" .
	log_print("/var/log/smgw.log") .
	"			<h2>Error Logfile</h2>\n" .
	log_print("/var/log/smgw.err") .
	"		</div>\n" .
	"		<div class=\"bottom\"><img src=\"img/bg_bottom.png\"></div>\n" .
	"	</div>\n" .
	"</body>\n" .
	"</html>";

?>
